// GLOBAL CONFIGURATION
var options_less_path = "";
var options_css_alongside_less = "0";
var options_output_type = "1"; // 0 => normal, 1 => minified, 2 => both
var options_minify_compatibility = "IE7";
var options_advanced_optimizations = "0";

function SaveLessOnOptions()
{
  var form = new TForm(WeBuilder);
  form.Width = 400;
  form.Height = 254;
  form.Position = poScreenCenter;
  form.BorderStyle = bsSingle;
  form.BorderIcons = biSystemMenu;
  form.Caption = "Save LESS Options";

  // LESS PATH
  var label_less_path = new TLabel(form);
  label_less_path.Parent = form;
  label_less_path.Caption = "LESS Compiler path:";
  label_less_path.SetBounds(8, 8, 340, 15);

  var input_less_path = new TEdit(form);
  input_less_path.Parent = form;
  input_less_path.Text = options_less_path;
  input_less_path.SetBounds(8, 24, 376, 21);

  var label_less_path_note = new TLabel(form);
  label_less_path_note.Parent = form;
  label_less_path_note.Caption = "If path contains spaces, add double quotes around it";
  label_less_path_note.SetBounds(10, 48, 376, 15);

  // OUTPUT TYPE
  var label_output_type = new TLabel(form);
  label_output_type.Parent = form;
  label_output_type.Caption = "Output type:";
  label_output_type.SetBounds(10, 72, 340, 15);

  var combo_output_type = new TComboBox(form);
  combo_output_type.Parent = form;
  combo_output_type.Style = csDropDownList;
  combo_output_type.setBounds(10, 88, 372, 15);
  combo_output_type.Items.Add("Normal CSS");
  combo_output_type.Items.Add("Minified CSS");
  combo_output_type.Items.Add("Both");

  if(options_output_type=="0")
  {
    combo_output_type.ItemIndex = 0;
  }
  else if(options_output_type=="1")
  {
    combo_output_type.ItemIndex = 1;
  }
  else if(options_output_type=="2")
  {
    combo_output_type.ItemIndex = 2;
  }

  // CSS ALONGSIDE LESS
  var check_css_alongside_less = new TCheckBox(form);
  check_css_alongside_less.Parent = form;
  check_css_alongside_less.Checked = (options_css_alongside_less=="1");
  check_css_alongside_less.setBounds(10, 120, 15, 15);

  var label_css_alongside_less = new TLabel(form);
  label_css_alongside_less.Parent = form;
  label_css_alongside_less.Caption = "Place CSS files alongside LESS files";
  label_css_alongside_less.setBounds(28, 120, 326, 15);

  // CLEAN CSS COMPATIBILITY
  var label_compatibility = new TLabel(form);
  label_compatibility.Parent = form;
  label_compatibility.Caption = "Clean CSS compatibility:";
  label_compatibility.SetBounds(10, 148, 340, 15);

  var radio_compatibility_ie7 = new TRadioButton(form);
  radio_compatibility_ie7.Parent = form;
  radio_compatibility_ie7.Checked = (options_minify_compatibility=="IE7");
  radio_compatibility_ie7.setBounds(10, 164, 15, 15);

  var label_compatibility_ie7 = new TLabel(form);
  label_compatibility_ie7.Parent = form;
  label_compatibility_ie7.Caption = "IE7";
  label_compatibility_ie7.setBounds(28, 165, 30, 15);

  var radio_compatibility_ie8 = new TRadioButton(form);
  radio_compatibility_ie8.Parent = form;
  radio_compatibility_ie8.Checked = (options_minify_compatibility=="IE8");
  radio_compatibility_ie8.setBounds(60, 164, 15, 15);

  var label_compatibility_ie8 = new TLabel(form);
  label_compatibility_ie8.Parent = form;
  label_compatibility_ie8.Caption = "IE8";
  label_compatibility_ie8.setBounds(78, 165, 30, 15);

  // ADVANCED OPTIMIZATIONS
  var check_advanced_opt = new TCheckBox(form);
  check_advanced_opt.Parent = form;
  check_advanced_opt.Checked = (options_advanced_optimizations=="1");
  check_advanced_opt.setBounds(150, 164, 15, 15);

  var label_advanced_opt = new TLabel(form);
  label_advanced_opt.Parent = form;
  label_advanced_opt.Caption = "Advanced optimizations";
  label_advanced_opt.setBounds(168, 165, 150, 15);

  // BUTTON OK
  var button_ok = new TButton(form);
  button_ok.Parent = form;
  button_ok.SetBounds(8, 192, 75, 25);
  button_ok.Caption = "Save";
  button_ok.Default = True;
  button_ok.ModalResult = mrOK;

  // BUTTON CANCEL
  var button_cancel = new TButton(form);
  button_cancel.Parent = form;
  button_cancel.SetBounds(95, 192, 75, 25);
  button_cancel.Caption = "Cancel";
  button_cancel.Cancel = True;
  button_cancel.ModalResult = mrCancel;

  var r = form.ShowModal;

  if(r==mrOK)
  {
    options_less_path = input_less_path.Text;

    if(combo_output_type.ItemIndex==0)
    {
      options_output_type = "0";
    }
    else if(combo_output_type.ItemIndex==1)
    {
      options_output_type = "1";
    }
    else if(combo_output_type.ItemIndex==2)
    {
      options_output_type = "2";
    }

    if(check_css_alongside_less.Checked)
    {
      options_css_alongside_less = "1";
    }
    else options_css_alongside_less = "0";

    if(radio_compatibility_ie7.Checked)
    {
      options_minify_compatibility = "IE7";
    }

    if(radio_compatibility_ie8.Checked)
    {
      options_minify_compatibility = "IE8";
    }

    if(check_advanced_opt.Checked)
    {
      options_advanced_optimizations = "1";
    }
    else options_advanced_optimizations = "0";

    Script.WriteSetting("less_path", options_less_path);
    Script.WriteSetting("output_type", options_output_type);
    Script.WriteSetting("css_alongside_less", options_css_alongside_less);
    Script.WriteSetting("compatibility", options_minify_compatibility);
    Script.WriteSetting("advanced_optimizations", options_advanced_optimizations);
  }

  delete f;
}

function SaveLessOnInstalled()
{
  options_less_path = Script.ReadSetting("less_path", "");
  options_output_type = Script.ReadSetting("output_type", "1");
  options_css_alongside_less = Script.ReadSetting("css_alongside_less", "0");
  options_minify_compatibility = Script.ReadSetting("compatibility", "IE7");
  options_advanced_optimizations = Script.ReadSetting("advanced_optimizations", "0");
}

function SaveLessOnSave(document)
{
  var ext = ExtractFileExt(document.FileName);

  if(ext==".less")
  {
    SaveLess(document, -1);
  }
}

function SaveLessOnCompileNormal()
{
  var ext = ExtractFileExt(Document.FileName);

  if(ext==".less")
  {
    SaveLess(Document, 0);
  }
}

function SaveLessOnCompileMinified()
{
  var ext = ExtractFileExt(Document.FileName);

  if(ext==".less")
  {
    SaveLess(Document, 1);
  }
}

function SaveLessClearStatusBar()
{
  Script.Status = "";
}

function SaveLess(document, output_type)
{
  var first_line = Trim(Editor.Lines[0]);
  var source_filename = document.FileName;

  if(options_less_path=="")
  {
    Alert("Please set LESS compiler path (See Plugins > Save LESS > Options)");

    return;
  }

  if(output_type==-1)
  {
    output_type = options_output_type;
  }

  if(Copy(first_line, 1, 7)=="//@main")
  {
    var space = Pos(" ", first_line);

    if(space>0)
    {
      source_filename = ExtractFilePath(document.FileName) + Copy(first_line, space + 1, Length(first_line) - space);
    }
  }

  var output = "";
  var command = "";
  var has_error = 0;
  var destination_filename = "";

  if(options_css_alongside_less=="1")
  {
    destination_filename = ExtractFilePath(source_filename) + Replace(ExtractFileName(source_filename), ".less", ".css");
  }
  else destination_filename = Replace(ExtractFilePath(source_filename), "\\less\\", "\\css\\") + Replace(ExtractFileName(source_filename), ".less", ".css");

  // COMPILE LESS FILE
  if((output_type==0) || (output_type==2))
  {
    command = options_less_path;

    command += " --no-color --silent";
    command += " \"" + source_filename + "\"";
    command += " \"" + destination_filename + "\"";

    ExecuteCommand(command, output);

    if(output!="")
    {
      has_error = 1;
      Alert(output);
    }
  }

  // COMPILE MINIFIED LESS FILE
  if(((output_type==1) || (output_type==2)) && (has_error==0))
  {
    var compatilility = "";
    var advanced = "";

    if(options_minify_compatibility=="IE7")
    {
      compatilility = "ie7";
    }
    else if(options_minify_compatibility=="IE8")
    {
      compatilility = "ie8";
    }

    if(options_advanced_optimizations=="1")
    {
      advanced = "--advanced";
    }
    else advanced = "--skip-advanced";

    command = options_less_path;

    command += " --clean-css=\"--compatibility=" + compatilility + " " + advanced + "\" --no-color --silent";
    command += " \"" + source_filename + "\"";
    command += " \"" + ExtractFilePath(destination_filename) + Replace(ExtractFileName(destination_filename), ".css", ".min.css") + "\"";

    output = "";

    ExecuteCommand(command, output);

    if(output!="")
    {
      has_error = 1;
      Alert(output);
    }
  }

  if(has_error==0)
  {
    Script.Status = "Saved and compiled";
    Script.TimeOut(4000, &SaveLessClearStatusBar);
  }
}

Script.RegisterDocumentAction("Save LESS", "Compile LESS file (normal)", "", &SaveLessOnCompileNormal);
Script.RegisterDocumentAction("Save LESS", "Compile LESS file (minified)", "", &SaveLessOnCompileMinified);
Script.RegisterAction("Save LESS", "Options", "", &SaveLessOnOptions);

Script.ConnectSignal("ready", &SaveLessOnInstalled);
Script.ConnectSignal("document_after_save", &SaveLessOnSave);
